import { create } from "ipfs-http-client";
import urlJoin from "url-join";
import { ipfsAPI, publicIPFSGateway, privateIPFSGateway } from "./conf.js";
var gwType;
(function (gwType) {
    gwType["public"] = "public";
    gwType["private"] = "private";
})(gwType || (gwType = {}));
function getGw(type) {
    switch (type) {
        case gwType.public:
            return publicIPFSGateway;
        case gwType.private:
            return privateIPFSGateway;
    }
}
export function GetGatewayURL(ipfsPath, type) {
    const gw = getGw(type);
    return urlJoin(gw, ipfsPath);
}
const ipfs = create({
    url: ipfsAPI,
});
export default ipfs;
//# sourceMappingURL=ipfs.js.map